navigation_portlet_layout = {
    'widgets': {
        'show_docs': {
            'type': 'Boolean Widget',
            'data': {
                'title': '',
                'fields': ('show_docs',),
                'is_required': False,
                'label': '',
                'label_edit': 'cpsportlets_navigation_show_docs_label',
                'description': '',
                'help': '',
                'is_i18n': True,
                'readonly_layout_modes': (),
                'hidden_layout_modes': ('view',),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': "python: context.display not in ['folder_contents']",
                'label_false': 'cpsschemas_label_false',
                'label_true': 'cpsschemas_label_true',
                'render_format': 'select',
            },
        },
        'i18n': {
            'type': 'Boolean Widget',
            'data': {
                'title': '',
                'fields': ('i18n',),
                'is_required': False,
                'label': '',
                'label_edit': 'label_cpsportlets_i18n',
                'description': '',
                'help': '',
                'is_i18n': True,
                'readonly_layout_modes': (),
                'hidden_layout_modes': ('view',),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'label_false': 'cpsschemas_label_false',
                'label_true': 'cpsschemas_label_true',
                'render_format': 'select',
            },
        },
        'display': {
            'type': 'Select Widget',
            'data': {
                'title': '',
                'fields': ('display',),
                'is_required': False,
                'label_edit': 'cpsportlets_display_mode_label',
                'is_i18n': True,
                'hidden_layout_modes': ('view',),
                'vocabulary': 'cpsportlets_navigation_display_voc',
                'translated': True,
            },
        },
        'rel_depth': {
            'type': 'Int Widget',
            'data': {
                'title': '',
                'fields': ('rel_depth',),
                'is_required': False,
                'label': '',
                'label_edit': 'cpsportlets_navigation_rel_depth_label',
                'description': '',
                'help': '',
                'is_i18n': True,
                'readonly_layout_modes': (),
                'hidden_layout_modes': ('view',),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': "python: context.display in ['folder_contents', 'subfolder_contents', 'navigation_tree', 'site_map']",
                'is_limited': False,
                'min_value': 0.0,
                'max_value': 0.0,
                'thousands_separator': '',
            },
        },
        'end_depth': {
            'type': 'Int Widget',
            'data': {
                'title': '',
                'fields': ('end_depth',),
                'is_required': False,
                'label': '',
                'label_edit': 'cpsportlets_navigation_end_depth_label',
                'description': '',
                'help': '',
                'is_i18n': True,
                'readonly_layout_modes': (),
                'hidden_layout_modes': ('view',),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': "python: context.display in ['folder_contents', 'subfolder_contents']",
                'is_limited': False,
                'min_value': 0.0,
                'max_value': 0.0,
                'thousands_separator': '',
            },
        },
        'contextual': {
            'type': 'Boolean Widget',
            'data': {
                'title': '',
                'fields': ('contextual',),
                'is_required': False,
                'label': '',
                'label_edit': 'cpsportlets_navigation_contextual_label',
                'description': '',
                'help': '',
                'is_i18n': True,
                'readonly_layout_modes': (),
                'hidden_layout_modes': ('view',),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': "python: context.display in ['vertical_breadcrumbs_menu', 'folder_contents', 'subfolder_contents', 'site_map']",
                'label_false': 'cpsschemas_label_false',
                'label_true': 'cpsschemas_label_true',
                'render_format': 'select',
            },
        },
        'show_icons': {
            'type': 'Boolean Widget',
            'data': {
                'title': '',
                'fields': ('show_icons',),
                'is_required': False,
                'label': '',
                'label_edit': 'cpsportlets_navigation_show_icons_label',
                'description': '',
                'help': '',
                'is_i18n': True,
                'readonly_layout_modes': (),
                'hidden_layout_modes': ('view',),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': "python: context.display in ['vertical_breadcrumbs_menu', 'folder_contents', 'subfolder_contents']",
                'label_false': 'cpsschemas_label_false',
                'label_true': 'cpsschemas_label_true',
                'render_format': 'select',
            },
        },
        'portlet': {
            'type': 'Generic Portlet Widget',
            'data': {
                'title': '',
                'fields': ('portlet',),
                'hidden_layout_modes': ('edit',),
                'render_method': 'widget_portlet_navigation',
                'field_types': ('CPS String Field',),
            },
        },
        'root_uid': {
            'type': 'String Widget',
            'data': {
                'title': '',
                'fields': ('root_uid',),
                'label_edit': 'cpsportlets_navigation_root_uid_label',
                'is_i18n': True,
                'hidden_layout_modes': ('view',),
                'hidden_if_expr': "python: context.display in ['vertical_breadcrumbs_menu', 'folder_contents']",
                'display_width': 40,
                'size_max': 0,
            },
        },
    },
    'layout': {
        'style_prefix': 'layout_portlet_',
        'flexible_widgets': (),
        'ncols': 3,
        'rows': [
            [{'widget_id': 'portlet', 'ncols': 3},
            ],
            [{'widget_id': 'display', 'ncols': 3},
            ],
            [{'widget_id': 'root_uid', 'ncols': 1},
             {'widget_id': 'rel_depth', 'ncols': 1},
             {'widget_id': 'end_depth', 'ncols': 2},
             {'widget_id': 'contextual', 'ncols': 1},
            ],
            [{'widget_id': 'show_docs', 'ncols': 1},
             {'widget_id': 'show_icons', 'ncols': 2},
            ],
            [{'widget_id': 'i18n', 'ncols': 3},
            ],
        ],
    },
}

layouts = {'navigation_portlet': navigation_portlet_layout}
return layouts
